﻿using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Telerik.Windows.Data;
using Telerik.Windows.Controls;
using System.Collections.Specialized;
using Telerik.Windows.Data;
using System.Linq;
using System.Linq.Expressions;

namespace RadGridView_WPF_AR_4
{
	/// <summary>
	/// Interaction logic for MainWindow.xaml
	/// </summary>
	public partial class MainWindow : Window
	{
		private static readonly System.Linq.Expressions.Expression parameterExpression = System.Linq.Expressions.Expression.Parameter(typeof(Player), "player");
		private System.Linq.Expressions.Expression currentExpression = System.Linq.Expressions.Expression.Constant(FilterDescriptor.UnsetValue);

		public MainWindow()
		{
			InitializeComponent();

			this.radDataFilter.FilterDescriptors.CollectionChanged += new NotifyCollectionChangedEventHandler(FilterDescriptors_CollectionChanged);
			this.radDataFilter.FilterDescriptors.ItemChanged += new EventHandler<ItemChangedEventArgs<IFilterDescriptor>>(FilterDescriptors_ItemChanged);
		}

		void FilterDescriptors_ItemChanged(object sender, ItemChangedEventArgs<IFilterDescriptor> e)
		{
			this.ReEvaluateFilteringExpression();
		}

		void FilterDescriptors_CollectionChanged(object sender, NotifyCollectionChangedEventArgs e)
		{
			this.ReEvaluateFilteringExpression();
		}

		private void ReEvaluateFilteringExpression()
		{
			var newExpression = this.radDataFilter.FilterDescriptors.CreateFilterExpression(parameterExpression);

			if (newExpression.ToString() != this.currentExpression.ToString())
			{
				Debug.WriteLine("Filtering Expression Changed!");
				this.currentExpression = newExpression;
			}
		}
	}
}
